Obfuscating user data

Obfuscation is a form of data destruction that permanently overwrites data in certain fields with randomized data (such as GUIDs). These actions cannot be undone.

Note: This process differs from the process described in the Cloud API Developer Guide. Obfuscating response data leaves the data intact in the database and obfuscates only the data displayed in the response. The endpoints described here obfuscate at the database level, permanently overwriting the data in the database.

PolicyCenter provides an endpoint to obfuscate user data. The user must be inactive (the active attribute must be set to false) for the user to be obfuscated.

The following endpoint obfuscates a user’s data:

  • POST /admin/v1/users/{userId}/obfuscate

This example demonstrates obfuscating PII for user pc:120.

Before obfuscating, if you retrieve information for user pc:120 you’ll see something like this:

{
    "data": {
        "attributes": {
            "active": false,
            "displayName": "Ronald Rutherford",
            "externalUser": false,
            "firstName": "Ronald",
            "id": "pc:120",
            "lastName": "Rutherford",
            "username": "rrutherford",
            …
        },

You can then use the following endpoint to obfuscate the record for user pc:120:

POST/admin/v1/users/pc:120/obfuscate

No request body is required for this POST action.

The response shows that fields with PII, such as displayName and userName, have all been overwritten:

{
    "data": {
        "attributes": {
            "active": false,
            "displayName": "71633b5ed0dba332f1f4b645682c6d 71633b5ed0dba332f1f4b645682c6d",
            "externalUser": false,
            "firstName": "71633b5ed0dba332f1f4b645682c6d",
            "id": "pc:120",
            "lastName": "71633b5ed0dba332f1f4b645682c6d",
            "username": "80aef0777aa07c8cf79b454bab2df5",
…
        },

After obfuscation, you can still retrieve the user record based on ID, but there is no way to personally identify that user.